///////////////////////////////
#include <acknex.h>
#include <default.c>
#include <windows.h>
///////////////////////////////

FONT* arial = "Arial#20b";
FONT* arial_med = "Arial#18b";
FONT* arial_sm = "Arial#15b";

var fullscreen;

var button_pressed;

var ents_num = 0;
var lights_num = 0;
var sounds_num = 0;

var ent_drag = 0;


var unsnapped_ang[3];
var unsnapped_pos[3];
var unsnapped_sca[3];

#include "defines.c"
#include "graphics.c"
#include "settings.c"
#include "level.c"
#include "camera.c"
#include "ui.c"
#include "materials.c"
#include "properties.c"
#include "entities.c"
#include "opensave.c"

BMAP* mouse = "mouse.bmp";

void update_ui()
{
	properties.pos_x = 2; 
   properties.pos_y = screen_size.y - bmap_height(properties.bmap) - 2;
	light_properties.pos_x = 2; 
   light_properties.pos_y = screen_size.y - bmap_height(light_properties.bmap) - 2;
	sound_properties.pos_x = 2; 
   sound_properties.pos_y = screen_size.y - bmap_height(sound_properties.bmap) - 2;
	info_pan.pos_x = screen_size.x - 110;
   info_pan.pos_y = screen_size.y - 65;
   ver.pos_x = screen_size.x/2 - 200;
   ver.pos_y = screen_size.y - 20;
}

void toggle_screen()
{
	if(video_mode==7)
	{
		video_switch (8,32,1);
		mouse_map = mouse;
		fullscreen=1;
		update_ui();
	}
	else
	{
		video_switch (7,32,2);
		mouse_map = 0;
		fullscreen=0;
		update_ui();
	}
}

void toggle_shadow()
{
	shadow_stencil = (shadow_stencil==OFF);
}

void move_object()
{
   STRING* temp = "#10";
   str_cpy(selection_pos,"X:");
   str_for_num(temp,integer(selected.x));
   str_cat(selection_pos,temp);
   str_cat(selection_pos," Y:");
   str_for_num(temp,integer(selected.y));
   str_cat(selection_pos,temp);
   str_cat(selection_pos," Z:");
   str_for_num(temp,integer(selected.z));
   str_cat(selection_pos,temp);
}

void rotate_object()
{
   STRING* temp = "#10";
   str_cpy(selection_ang,"Pan:");
   str_for_num(temp,integer(selected.pan));
   str_cat(selection_ang,temp);
   str_cat(selection_ang," Tilt:");
   str_for_num(temp,integer(selected.tilt));
   str_cat(selection_ang,temp);
   str_cat(selection_ang," Roll:");
   str_for_num(temp,integer(selected.roll));
   str_cat(selection_ang,temp);
}

void scale_object()
{
   STRING* temp = "#10";
   str_cpy(selection_scale,"X:");
   str_for_num(temp,integer(selected.scale_x));
   str_cat(selection_scale,temp);
   str_cat(selection_scale," Y:");
   str_for_num(temp,integer(selected.scale_y));
   str_cat(selection_scale,temp);
   str_cat(selection_scale," Z:");
   str_for_num(temp,integer(selected.scale_z));
   str_cat(selection_scale,temp);
}

void ground_align()
{
	VECTOR trace_dir;
	ANGLE grnd;
	button_pressed = 1;
	
	you = selected;
	vec_set(trace_dir,you.x);
	trace_dir.z-=1000;
	c_trace(you.x,trace_dir,IGNORE_PASSABLE | IGNORE_YOU | USE_POLYGON);
	
	if(trace_hit)
	{
		selected.z = target.z - (selected.min_z);
	}
	
	grnd.pan = 0;
	grnd.tilt = - asin(normal.x);
	grnd.roll = - asin(normal.y);
	
	var old_pan;
	
	old_pan = selected.pan;
	vec_set(selected.pan,grnd);
   ang_rotate(selected.pan,vector(old_pan,0,0));
   
   wait(5);
   button_pressed = 0;
}

void draw_bounding_box(ENTITY* ent)
{
	 VECTOR bounding_box[8];
    
    vec_set(bounding_box[0],vector(ent.min_x,ent.min_y,ent.min_z));
    vec_rotate(bounding_box[0],ent.pan);
    vec_add(bounding_box[0],ent.x);
    
    vec_set(bounding_box[1],vector(ent.min_x,ent.max_y,ent.min_z));
    vec_rotate(bounding_box[1],ent.pan);
    vec_add(bounding_box[1],ent.x);
    
    vec_set(bounding_box[2],vector(ent.max_x,ent.max_y,ent.min_z));
    vec_rotate(bounding_box[2],ent.pan);
    vec_add(bounding_box[2],ent.x);
    
    vec_set(bounding_box[3],vector(ent.max_x,ent.min_y,ent.min_z));
    vec_rotate(bounding_box[3],ent.pan);
    vec_add(bounding_box[3],ent.x);
    
    vec_set(bounding_box[4],vector(ent.min_x,ent.min_y,ent.max_z));
    vec_rotate(bounding_box[4],ent.pan);
    vec_add(bounding_box[4],ent.x);
    
    vec_set(bounding_box[5],vector(ent.min_x,ent.max_y,ent.max_z));
    vec_rotate(bounding_box[5],ent.pan);
    vec_add(bounding_box[5],ent.x);
    
    vec_set(bounding_box[6],vector(ent.max_x,ent.max_y,ent.max_z));
    vec_rotate(bounding_box[6],ent.pan);
    vec_add(bounding_box[6],ent.x);
    
    vec_set(bounding_box[7],vector(ent.max_x,ent.min_y,ent.max_z));
    vec_rotate(bounding_box[7],ent.pan);
    vec_add(bounding_box[7],ent.x);
    
    draw_line3d(bounding_box[0],NULL,100);
    draw_line3d(bounding_box[1],vector(0,0,255),100);
    draw_line3d(bounding_box[2],vector(0,0,255),100);
    draw_line3d(bounding_box[3],vector(0,0,255),100);
    draw_line3d(bounding_box[0],vector(0,0,255),100);
    draw_line3d(bounding_box[4],vector(0,0,255),100);
    draw_line3d(bounding_box[5],vector(0,0,255),100);
    draw_line3d(bounding_box[6],vector(0,0,255),100);
    draw_line3d(bounding_box[7],vector(0,0,255),100);
    draw_line3d(bounding_box[4],vector(0,0,255),100);
    draw_line3d(bounding_box[1],NULL,100);
    draw_line3d(bounding_box[5],vector(0,0,255),100);
    draw_line3d(bounding_box[2],NULL,100);
    draw_line3d(bounding_box[6],vector(0,0,255),100);
    draw_line3d(bounding_box[3],NULL,100);
    draw_line3d(bounding_box[7],vector(0,0,255),100);
}


void check_shortcuts()
{
	while(1)
	{
	if(key_ctrl)
	{
		if(key_n)
		{
			while(key_n){wait(1);}
			new_level();
		}
		if(key_o)
		{
			while(key_o){wait(1);}
			open_level();
		}
		if(key_s)
		{
			while(key_s){wait(1);}
			save_level_old();
		}
		
		if(key_x)
		{
			while(key_x){wait(1);}
			press_cut();
		}
		if(key_c)
		{
			while(key_c){wait(1);}
			press_copy();
		}
		if(key_v)
		{
			while(key_v){wait(1);}
			press_paste();
		}
		
		if(key_j)
		{
			while(key_j){wait(1);}
			light_props();
		}
		if(key_k)
		{
			while(key_k){wait(1);}
			fog_props();
		}
		if(key_l)
		{
			while(key_l){wait(1);}
			set_sky();
		}
	}
	else
	{
	   if(key_del)
	   {
		   while(key_del){wait(1);}
		   obj_delete();
	   }
	
	   if(key_y)
	   {
			while(key_y){wait(1);}
			add_model();
	   }
		if(key_u)
		{
			while(key_u){wait(1);}
			add_terrain();
		}
		if(key_i)
		{
			while(key_i){wait(1);}
			add_sprite();
		}
		if(key_o)
		{
			while(key_o){wait(1);}
			add_light();
		}
		if(key_p)
		{
			while(key_p){wait(1);}
			add_sound();
		}
		
		if(key_1)
		{
			while(key_1){wait(1);}
			persp_cam();
		}
		if(key_2)
		{
			while(key_2){wait(1);}
			top_cam();
		}
		if(key_3)
		{
			while(key_3){wait(1);}
			front_cam();
		}
		if(key_4)
		{
			while(key_4){wait(1);}
			side_cam();
		}
	}
	wait(1);
   }
}

void static_scale(ENTITY * ent, var factor)
{
	ent.scale_x = factor*maxv(0,(vec_dist(ent.x,camera.x))*0.008);
   ent.scale_y = factor*maxv(0,(vec_dist(ent.x,camera.x))*0.008);
   ent.scale_z = factor*maxv(0,(vec_dist(ent.x,camera.x))*0.008);
}

var wndf=0;

void selection_update()
{
	if(selected)
    {
    selected.x+=(key_end-key_pgdn)*move_mul/2*time_step;
    selected.y+=(key_cul-key_cur)*move_mul/2*time_step;
    selected.z+=(key_home-key_pgup)*move_mul/2*time_step;
    if(z_arrow)
    {
    if(cam_mode!=2)
    {
    reset(z_arrow,INVISIBLE);
    }
    else
    {
    set(z_arrow,INVISIBLE);
    }
    if(cam_mode!=3)
    {
    reset(x_arrow,INVISIBLE);
    }
    else
    {
    set(x_arrow,INVISIBLE);
    }
    if(cam_mode!=4)
    {
    reset(y_arrow,INVISIBLE);
    }
    else
    {
    set(y_arrow,INVISIBLE);
    }
    static_scale(x_arrow, 0.75);
    static_scale(y_arrow, 0.75);
    static_scale(z_arrow, 0.75);
    
    vec_set(x_arrow.x,selected.x);
    x_arrow.x+=10;
    vec_set(y_arrow.x,selected.x);
    y_arrow.y+=10;
    vec_set(z_arrow.x,selected.x);
    z_arrow.z+=10;
    }

    
    if(selected.obj_type==light_source)
    {
    	if(mouse_left)
		{
			selected.red = select_light_red;
			selected.green = select_light_green;
			selected.blue = select_light_blue;
		}
		else
		{
			select_light_red = selected.red;
			select_light_green = selected.green;
			select_light_blue = selected.blue;
		}
    }
    move_object();
    rotate_object();
    scale_object();
    }
    else
    {
    if(z_arrow)
    {
    set(x_arrow,INVISIBLE);
    set(y_arrow,INVISIBLE);
    set(z_arrow,INVISIBLE);
    }
    }
}

void main()
{
   str_cpy(save_dir,work_dir);
   str_cat(save_dir,"\\levels");

	video_window(0,0,112,"Visual Level Editor");
	video_mode = 7;
	d3d_entsort = 2;
	d3d_lightres = 1;
	terrain_chunk = 0;
	warn_level = 4;
	shadow_stencil = 1;
	sound_vol = 100;
	midi_vol = 100;
	mouse_mode = 1;
	mouse_pointer = 2;
	mouse_spot.x = 3;
   mouse_spot.y = 6; 
	mouse_range = 100000;
	doppler_factor = 0;	
	
	load_prefrences();
	wait(3);
	add_folder(image_folder);
	add_folder(models_folder);
	add_folder(terrains_folder);
	add_folder(sounds_folder);
	
	on_esc = NULL;
	on_close = exit_editor;

	on_mouse_left = select;
	on_space = toggle_screen;
	on_b = toggle_shadow;
	//on_m = publish_level; //crashes in compiled version
	
	text_to_panel(open_file,files_list);
	text_to_panel(properties,props);
	text_to_panel(save_file,save_name);
	text_to_panel(input_text,enter_name);
	text_to_panel(input_vec,enter_vecX);
	text_to_panel(input_vec,enter_vecY);
	text_to_panel(input_vec,enter_vecZ);
	text_to_panel(fog_properties,fg_strt);
	text_to_panel(fog_properties,fg_end);
	text_to_panel(light_properties,enter_light);
	text_to_panel(sound_properties,sound_props);
	text_to_panel(sound_properties,enter_vol);
	text_to_panel(prefrences,prefs_txt);
	
	update_window_name();
	
	wait(1);
	update_ui();
	
	check_shortcuts();
	
	if(!file_open_read("config.cfg"))//no cfg found -> show first run dialog
	{
	str_cpy(image_folder,work_dir);
	str_cpy(models_folder,work_dir);
	str_cpy(terrains_folder,work_dir);
	str_cpy(sounds_folder,work_dir);
	show_dialog(first_run);
   }
   
   if(str_stri(command_str,":\\"))//used as application to open a file
   {
   	STRING* levelname = str_create("#50");
   	STRING* leveldir = str_create("#50");
      STRING* slash = "\\";
      
      str_clip(slash,1);
   	str_cpy(levelname,command_str);
   	str_cpy(leveldir,command_str);
   	
   	var temp_num=0;
   	var letter_num = 0;
   	while(1)
   	{
   	temp_num = str_stri(levelname,slash);
   	letter_num+=temp_num;
      if(temp_num){str_clip(levelname,temp_num);}
      else{break;}
   	}
   	str_trunc(leveldir,str_len(leveldir)-letter_num);
      str_clip(leveldir,1);
      str_trunc(levelname,1);
      str_trunc(leveldir,1);
      str_cpy(save_dir,leveldir);

      load_level(levelname);
      str_cpy(curr_level_name,levelname);
	   update_window_name();
   }
   else
   {
   	new_level();
   }
   while (1)
   {
    if(key_shift){move_mul=20;}
    else{move_mul=10;}
    
    mouse_pos.x = mouse_cursor.x;    
    mouse_pos.y = mouse_cursor.y;
    
    def_dfps = 0.9*def_dfps+0.1/time_frame;
    
    selection_update();
    
    
    mat_model.ambient_red = amb_light.red;
    mat_model.ambient_green = amb_light.green;
    mat_model.ambient_blue = amb_light.blue;
    
    if (!window_focus)
    {
	 if (!wndf)
	 {
		wndf=1;
		reset(camera,VISIBLE);
		fps_max=4;
		freeze_mode = 1;
	 }
	 }
	 else
	 {
		if (wndf)
		{
			freeze_mode = 0;
			fps_max=40;
			set(camera,VISIBLE);
			wndf=0;
		}
	 }
    wait(1);
   }
}